diff --git a/src/main/java/net/minecraft/core/world/wind/WindManagerGeneric.java b/src/main/java/net/minecraft/core/world/wind/WindProviderGeneric.java
similarity index 97%
rename from src/main/java/net/minecraft/core/world/wind/WindManagerGeneric.java
rename to src/main/java/net/minecraft/core/world/wind/WindProviderGeneric.java
index cde005071..d92ba3b2a 100644
--- a/src/main/java/net/minecraft/core/world/wind/WindManagerGeneric.java
+++ b/src/main/java/net/minecraft/core/world/wind/WindProviderGeneric.java
@@ -1,12 +1,11 @@
 package net.minecraft.core.world.wind;
 
-import net.minecraft.core.Global;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.noise.ImprovedNoise;
 
 import java.util.Random;
 
-public class WindManagerGeneric extends WindManager {
+public class WindProviderGeneric extends WindProvider {
     private final double perlinMax = Math.sqrt(3.0 / 4.0);
     
     private long randomSeed = -1;
diff --git a/src/main/java/net/minecraft/server/MinecraftServer.java b/src/main/java/net/minecraft/server/MinecraftServer.java
index 6bcab559d..684464006 100644
--- a/src/main/java/net/minecraft/server/MinecraftServer.java
+++ b/src/main/java/net/minecraft/server/MinecraftServer.java
@@ -4,27 +4,26 @@ import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.Global;
 import net.minecraft.core.MinecraftAccessor;
 import net.minecraft.core.achievement.stat.StatList;
-import net.minecraft.core.block.Block;
-import net.minecraft.core.crafting.legacy.CraftingManager;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.data.DataLoader;
 import net.minecraft.core.data.legacy.LegacyWorldTypes;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.SkinVariantList;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.ICommandListener;
 import net.minecraft.core.net.IUpdatePlayerListBox;
 import net.minecraft.core.net.NetworkManager;
 import net.minecraft.core.net.PropertyManager;
-import net.minecraft.core.net.ServerCommand;
+import net.minecraft.core.net.ServerCommandEntry;
 import net.minecraft.core.net.command.ServerCommandHandler;
-import net.minecraft.core.net.packet.Packet4UpdateTime;
+import net.minecraft.core.net.packet.SetTimePacket;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.sound.SoundTypes;
 import net.minecraft.core.util.helper.RSA;
 import net.minecraft.core.util.helper.RestHandler;
 import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.provider.BiomeProviderOverworld;
@@ -43,7 +42,7 @@ import net.minecraft.core.world.type.WorldType;
 import net.minecraft.core.world.type.WorldTypes;
 import net.minecraft.server.entity.EntityTracker;
 import net.minecraft.server.entity.ServerSkinVariantList;
-import net.minecraft.server.entity.player.EntityPlayerMP;
+import net.minecraft.server.entity.player.ServerPlayer;
 import net.minecraft.server.gui.ServerGui;
 import net.minecraft.server.net.ConsoleCommandHandler;
 import net.minecraft.server.net.NetworkListenThread;
@@ -88,7 +87,6 @@ public class MinecraftServer
         deathTime = 0;
         field_9010_p = new ArrayList();
         commands = Collections.synchronizedList(new ArrayList());
-        entityTracker = new EntityTracker[Dimension.getDimensionList().size()];
         new ThreadSleepForeverServer(this);
     }
 
@@ -172,8 +170,12 @@ public class MinecraftServer
         }
 
         // Manually initialize blocks and items
-        Block.initializeBlocks();
-        Item.initializeItems();
+        Blocks.init();
+        Items.init();
+
+        Dimension.init();
+
+        entityTracker = new EntityTracker[Dimension.getDimensionList().size()];
 
         new Registries();
         BiomeProviderOverworld.init();
@@ -183,7 +185,6 @@ public class MinecraftServer
         DataLoader.loadRecipesFromFile("/recipes/furnace.json");
         DataLoader.loadRecipesFromFile("/recipes/trommel.json");
         DataLoader.loadRecipesFromFile("/recipes/workbench.json");
-        CraftingManager.getInstance().init();
 
         DataLoader.loadDataPacks(this);
 
@@ -198,6 +199,8 @@ public class MinecraftServer
         
         I18n.initialize(language);
 
+        StatList.init();
+
         if (!statsToken.equals("only-enter-a-value-if-you-are-a-registered-server") && !(statsToken.equals("")))
         {
             statsStatus = true;
@@ -409,7 +412,7 @@ public class MinecraftServer
     {
         currentTask = s;
         percentDone = i;
-        logger.info((new StringBuilder()).append(s).append(": ").append(i).append("%").toString());
+        logger.info(s + ": " + i + "%");
     }
 
     private void clearCurrentTask()
@@ -489,7 +492,7 @@ public class MinecraftServer
                         {
                             timeSinceLastTick -= 10L;
                             i++;
-                            for (EntityPlayerMP player : playerList.playerEntities) {
+                            for (ServerPlayer player : playerList.playerEntities) {
                                 player.tickSendChunks();
                             }
                             if (i % 5 == 0) {
@@ -575,7 +578,7 @@ public class MinecraftServer
         }
 
         AABB.initializePool();
-        Vec3d.initializePool();
+        Vec3.initializePool();
         deathTime++;
         for (int i = 0; i < dimensionWorlds.length; i++)
         {
@@ -590,7 +593,7 @@ public class MinecraftServer
             WorldServer worldserver = dimensionWorlds[i];
             if (deathTime % 20 == 0)
             {
-                playerList.sendPacketToAllPlayersInDimension(new Packet4UpdateTime(worldserver.getWorldTime()), worldserver.dimension.id);
+                playerList.sendPacketToAllPlayersInDimension(new SetTimePacket(worldserver.getWorldTime()), worldserver.dimension.id);
             }
             worldserver.tick();
             while (worldserver.updatingLighting()) ;
@@ -621,15 +624,15 @@ public class MinecraftServer
 
     public void addCommand(String s, ICommandListener icommandlistener)
     {
-        commands.add(new ServerCommand(s, icommandlistener));
+        commands.add(new ServerCommandEntry(s, icommandlistener));
     }
 
     public void commandLineParser()
     {
-        ServerCommand servercommand;
+        ServerCommandEntry servercommand;
         for (; commands.size() > 0; commandHandler.handleCommand(servercommand))
         {
-            servercommand = (ServerCommand) commands.remove(0);
+            servercommand = commands.remove(0);
         }
 
     }
@@ -639,7 +642,7 @@ public class MinecraftServer
         field_9010_p.add(iupdateplayerlistbox);
     }
 
-    public static void main(String args[])
+    public static void main(String[] args)
     {
         try
         {
@@ -669,7 +672,6 @@ public class MinecraftServer
             throw new RuntimeException(e);
         }
         PropertyConfigurator.configure("log4j.properties");
-        StatList.init();
         try
         {
             MinecraftServer minecraftserver = new MinecraftServer();
@@ -759,7 +761,7 @@ public class MinecraftServer
     public static HashMap field_6037_b = new HashMap();
     public NetworkListenThread networkServer;
     public PropertyManager propertyManager;
-    public WorldServer dimensionWorlds[];
+    public WorldServer[] dimensionWorlds;
     public PlayerList playerList;
     private ConsoleCommandHandler commandHandler;
     private boolean serverRunning;
@@ -767,9 +769,9 @@ public class MinecraftServer
     int deathTime;
     public String currentTask;
     public int percentDone;
-    private List field_9010_p;
-    private List commands;
-    public EntityTracker entityTracker[];
+    private final List field_9010_p;
+    private final List<ServerCommandEntry> commands;
+    public EntityTracker[] entityTracker;
     public boolean onlineMode;
     public boolean spawnPeacefulMobs;
     public boolean pvpOn;
@@ -788,7 +790,7 @@ public class MinecraftServer
     public static boolean statsStatus;
     public boolean disablePhotoMode = false;
     public String motd = "";
-    private SkinVariantList skinVariantList = new ServerSkinVariantList();
+    private final SkinVariantList skinVariantList = new ServerSkinVariantList();
     public int autoSaveInterval = 5;
     public int chunksSavedPerAutosave = 24;
     public boolean forceSaveAllChunksOnAutosave = false;
diff --git a/src/main/java/net/minecraft/server/entity/EntityTracker.java b/src/main/java/net/minecraft/server/entity/EntityTracker.java
index 2534a1d2f..451bcd842 100644
--- a/src/main/java/net/minecraft/server/entity/EntityTracker.java
+++ b/src/main/java/net/minecraft/server/entity/EntityTracker.java
@@ -4,9 +4,9 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.net.entity.ITrackedEntry;
 import net.minecraft.core.net.entity.NetEntityHandler;
 import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.world.pathfinder.IdHashMap;
+import net.minecraft.core.util.collection.IntHashMap;
 import net.minecraft.server.MinecraftServer;
-import net.minecraft.server.entity.player.EntityPlayerMP;
+import net.minecraft.server.entity.player.ServerPlayer;
 
 import java.util.ArrayList;
 import java.util.HashSet;
@@ -15,14 +15,14 @@ import java.util.Set;
 
 public class EntityTracker {
     public final Set<EntityTrackerEntry> trackedEntitySet;
-    public final IdHashMap<EntityTrackerEntry> trackedEntityHashTable;
+    public final IntHashMap<EntityTrackerEntry> trackedEntityHashTable;
     public final MinecraftServer mcServer;
     public final int maxTrackingDistanceThreshold;
     public final int dimension;
 
     public EntityTracker(MinecraftServer minecraftserver, int dimId) {
         trackedEntitySet = new HashSet<>();
-        trackedEntityHashTable = new IdHashMap<>();
+        trackedEntityHashTable = new IntHashMap<>();
         mcServer = minecraftserver;
         dimension = dimId;
         maxTrackingDistanceThreshold = minecraftserver.playerList.getMaxTrackingDistance();
@@ -41,21 +41,21 @@ public class EntityTracker {
         if(trackingDistance > maxTrackingDistanceThreshold) {
             trackingDistance = maxTrackingDistanceThreshold;
         }
-        if(trackedEntityHashTable.containsItem(entity.id)) {
+        if(trackedEntityHashTable.containsValue(entity.id)) {
             throw new IllegalStateException("Entity is already tracked!");
         }
         EntityTrackerEntry trackerEntry = new EntityTrackerEntry(entity, trackingDistance, packetDelay, shouldSendMotionUpdates);
         trackedEntitySet.add(trackerEntry);
-        trackedEntityHashTable.add(entity.id, trackerEntry);
+        trackedEntityHashTable.put(entity.id, trackerEntry);
         trackerEntry.updatePlayerEntities(mcServer.getDimensionWorld(dimension).players);
         return trackerEntry;
     }
 
     public void untrackEntity(Entity entity)
     {
-        if(entity instanceof EntityPlayerMP)
+        if(entity instanceof ServerPlayer)
         {
-            EntityPlayerMP entityplayermp = (EntityPlayerMP)entity;
+            ServerPlayer entityplayermp = (ServerPlayer)entity;
             EntityTrackerEntry entitytrackerentry1;
             for(Iterator<EntityTrackerEntry> iterator = trackedEntitySet.iterator(); iterator.hasNext(); entitytrackerentry1.removeFromTrackedPlayers(entityplayermp))
             {
@@ -76,14 +76,14 @@ public class EntityTracker {
         ArrayList<Entity> arraylist = new ArrayList<>();
         for (EntityTrackerEntry entitytrackerentry : trackedEntitySet) {
             entitytrackerentry.tick(mcServer.getDimensionWorld(dimension).players);
-            if (entitytrackerentry.playerEntitiesUpdated && (entitytrackerentry.trackedEntity instanceof EntityPlayerMP)) {
+            if (entitytrackerentry.playerEntitiesUpdated && (entitytrackerentry.trackedEntity instanceof ServerPlayer)) {
                 arraylist.add(entitytrackerentry.trackedEntity);
             }
         }
 label0:
         for(int i = 0; i < arraylist.size(); i++)
         {
-            EntityPlayerMP entityplayermp = (EntityPlayerMP)arraylist.get(i);
+            ServerPlayer entityplayermp = (ServerPlayer)arraylist.get(i);
             Iterator<EntityTrackerEntry> iterator1 = trackedEntitySet.iterator();
             do
             {
@@ -119,7 +119,7 @@ label0:
         }
     }
 
-    public void removeTrackedPlayerSymmetric(EntityPlayerMP entityplayermp)
+    public void removeTrackedPlayerSymmetric(ServerPlayer entityplayermp)
     {
         EntityTrackerEntry entitytrackerentry;
         for(Iterator<EntityTrackerEntry> iterator = trackedEntitySet.iterator(); iterator.hasNext(); entitytrackerentry.removeTrackedPlayerSymmetric(entityplayermp))
diff --git a/src/main/java/net/minecraft/server/entity/EntityTrackerEntry.java b/src/main/java/net/minecraft/server/entity/EntityTrackerEntry.java
index 244c133c8..1edadfeeb 100644
--- a/src/main/java/net/minecraft/server/entity/EntityTrackerEntry.java
+++ b/src/main/java/net/minecraft/server/entity/EntityTrackerEntry.java
@@ -1,25 +1,23 @@
 package net.minecraft.server.entity;
 
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.entity.NetEntityHandler;
+import net.minecraft.core.net.packet.MoveEntityPacket;
 import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.Packet17Sleep;
-import net.minecraft.core.net.packet.Packet28EntityVelocity;
-import net.minecraft.core.net.packet.Packet29DestroyEntity;
-import net.minecraft.core.net.packet.Packet31RelEntityMove;
-import net.minecraft.core.net.packet.Packet32EntityLook;
-import net.minecraft.core.net.packet.Packet33RelEntityMoveLook;
-import net.minecraft.core.net.packet.Packet34EntityTeleport;
-import net.minecraft.core.net.packet.Packet35EntityNickname;
-import net.minecraft.core.net.packet.Packet40EntityMetadata;
-import net.minecraft.core.net.packet.Packet42EntityTagData;
-import net.minecraft.core.net.packet.Packet5PlayerInventory;
+import net.minecraft.core.net.packet.SleepPacket;
+import net.minecraft.core.net.packet.SetEntityMotionPacket;
+import net.minecraft.core.net.packet.RemoveEntityPacket;
+import net.minecraft.core.net.packet.TeleportEntityPacket;
+import net.minecraft.core.net.packet.EntityNicknamePacket;
+import net.minecraft.core.net.packet.SetEntityDataPacket;
+import net.minecraft.core.net.packet.EntityTagDataPacket;
+import net.minecraft.core.net.packet.SetEquippedItemPacket;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.data.SynchedEntityData;
-import net.minecraft.server.entity.player.EntityPlayerMP;
+import net.minecraft.server.entity.player.ServerPlayer;
 
 import java.util.HashSet;
 import java.util.List;
@@ -45,7 +43,7 @@ public class EntityTrackerEntry {
     private final boolean shouldSendMotionUpdates;
     private int ticksSinceLastTeleport;
     public boolean playerEntitiesUpdated;
-    public Set<EntityPlayerMP> trackedPlayers;
+    public Set<ServerPlayer> trackedPlayers;
     public EntityTrackerEntry(Entity entity, int trackingDistance, int packetDelay, boolean shouldSendMotionUpdates) {
         updateCounter = 0;
         ticksSinceLastTeleport = 0;
@@ -56,9 +54,9 @@ public class EntityTrackerEntry {
         this.trackingDistance = trackingDistance;
         this.packetDelay = packetDelay;
         this.shouldSendMotionUpdates = shouldSendMotionUpdates;
-        encodedPosX = MathHelper.floor_double(entity.x * 32D);
-        encodedPosY = MathHelper.floor_double(entity.y * 32D);
-        encodedPosZ = MathHelper.floor_double(entity.z * 32D);
+        encodedPosX = MathHelper.floor(entity.x * 32D);
+        encodedPosY = MathHelper.floor(entity.y * 32D);
+        encodedPosZ = MathHelper.floor(entity.z * 32D);
         encodedRotationYaw = MathHelper.floor_float((entity.yRot * 256F) / 360F);
         encodedRotationPitch = MathHelper.floor_float((entity.xRot * 256F) / 360F);
     }
@@ -75,7 +73,7 @@ public class EntityTrackerEntry {
         return trackedEntity.id;
     }
 
-    public void tick(List<EntityPlayer> list) {
+    public void tick(List<Player> list) {
         playerEntitiesUpdated = false;
         if(!firstUpdateDone || trackedEntity.distanceToSqr(lastTrackedEntityPosX, lastTrackedEntityPosY, lastTrackedEntityPosZ) > 16D) {
             lastTrackedEntityPosX = trackedEntity.x;
@@ -87,9 +85,9 @@ public class EntityTrackerEntry {
         }
         ticksSinceLastTeleport++;
         if(++updateCounter % packetDelay == 0) {
-            int entityX = MathHelper.floor_double(trackedEntity.x * 32D);
-            int entityY = MathHelper.floor_double(trackedEntity.y * 32D);
-            int entityZ = MathHelper.floor_double(trackedEntity.z * 32D);
+            int entityX = MathHelper.floor(trackedEntity.x * 32D);
+            int entityY = MathHelper.floor(trackedEntity.y * 32D);
+            int entityZ = MathHelper.floor(trackedEntity.z * 32D);
             int entityYaw = MathHelper.floor_float((trackedEntity.yRot * 256F) / 360F);
             int entityPitch = MathHelper.floor_float((trackedEntity.xRot * 256F) / 360F);
             int dx = entityX - encodedPosX;
@@ -103,13 +101,13 @@ public class EntityTrackerEntry {
                 trackedEntity.x = (double)entityX / 32D;
                 trackedEntity.y = (double)entityY / 32D;
                 trackedEntity.z = (double)entityZ / 32D;
-                packet = new Packet34EntityTeleport(trackedEntity.id, entityX, entityY, entityZ, (byte)entityYaw, (byte)entityPitch);
+                packet = new TeleportEntityPacket(trackedEntity.id, entityX, entityY, entityZ, (byte)entityYaw, (byte)entityPitch);
             } else if(hasMoved && hasLooked) {
-                packet = new Packet33RelEntityMoveLook(trackedEntity.id, (byte)dx, (byte)dy, (byte)dz, (byte)entityYaw, (byte)entityPitch);
+                packet = new MoveEntityPacket.PosRot(trackedEntity.id, (byte)dx, (byte)dy, (byte)dz, (byte)entityYaw, (byte)entityPitch);
             } else if(hasMoved) {
-                packet = new Packet31RelEntityMove(trackedEntity.id, (byte)dx, (byte)dy, (byte)dz);
+                packet = new MoveEntityPacket.Pos(trackedEntity.id, (byte)dx, (byte)dy, (byte)dz);
             } else if(hasLooked) {
-                packet = new Packet32EntityLook(trackedEntity.id, (byte)entityYaw, (byte)entityPitch);
+                packet = new MoveEntityPacket.Rot(trackedEntity.id, (byte)entityYaw, (byte)entityPitch);
             }
             if(shouldSendMotionUpdates) {
                 double d = trackedEntity.xd - lastTrackedEntityMotionX;
@@ -121,7 +119,7 @@ public class EntityTrackerEntry {
                     lastTrackedEntityMotionX = trackedEntity.xd;
                     lastTrackedEntityMotionY = trackedEntity.yd;
                     lastTrackedEntityMotionZ = trackedEntity.zd;
-                    sendPacketToTrackedPlayers(new Packet28EntityVelocity(trackedEntity.id, lastTrackedEntityMotionX, lastTrackedEntityMotionY, lastTrackedEntityMotionZ));
+                    sendPacketToTrackedPlayers(new SetEntityMotionPacket(trackedEntity.id, lastTrackedEntityMotionX, lastTrackedEntityMotionY, lastTrackedEntityMotionZ));
                 }
             }
             if(packet != null) {
@@ -129,7 +127,7 @@ public class EntityTrackerEntry {
             }
             SynchedEntityData synchedEntityData = trackedEntity.getEntityData();
             if(synchedEntityData.isDirty()) {
-                sendPacketToTrackedPlayersAndTrackedEntity(new Packet40EntityMetadata(trackedEntity.id, synchedEntityData));
+                sendPacketToTrackedPlayersAndTrackedEntity(new SetEntityDataPacket(trackedEntity.id, synchedEntityData));
             }
             if(hasMoved) {
                 encodedPosX = entityX;
@@ -142,37 +140,37 @@ public class EntityTrackerEntry {
             }
         }
         if(trackedEntity.hurtMarked) {
-            sendPacketToTrackedPlayersAndTrackedEntity(new Packet28EntityVelocity(trackedEntity));
+            sendPacketToTrackedPlayersAndTrackedEntity(new SetEntityMotionPacket(trackedEntity));
             trackedEntity.hurtMarked = false;
         }
         if (trackedEntity.hadNicknameSet) {
-            sendPacketToTrackedPlayersAndTrackedEntity(new Packet35EntityNickname(trackedEntity.id, ((EntityLiving) trackedEntity).nickname, ((EntityLiving) trackedEntity).chatColor));
+            sendPacketToTrackedPlayersAndTrackedEntity(new EntityNicknamePacket(trackedEntity.id, ((Mob) trackedEntity).nickname, ((Mob) trackedEntity).chatColor));
             trackedEntity.hadNicknameSet = false;
         }
     }
 
     public void sendPacketToTrackedPlayers(Packet packet) {
-        for (EntityPlayerMP playerMP : trackedPlayers){
+        for (ServerPlayer playerMP : trackedPlayers){
             playerMP.playerNetServerHandler.sendPacket(packet);
         }
     }
 
     public void sendPacketToTrackedPlayersAndTrackedEntity(Packet packet) {
         sendPacketToTrackedPlayers(packet);
-        if(trackedEntity instanceof EntityPlayerMP) {
-            ((EntityPlayerMP)trackedEntity).playerNetServerHandler.sendPacket(packet);
+        if(trackedEntity instanceof ServerPlayer) {
+            ((ServerPlayer)trackedEntity).playerNetServerHandler.sendPacket(packet);
         }
     }
 
     public void sendDestroyEntityPacketToTrackedPlayers() {
-        sendPacketToTrackedPlayers(new Packet29DestroyEntity(trackedEntity.id));
+        sendPacketToTrackedPlayers(new RemoveEntityPacket(trackedEntity.id));
     }
 
-    public void removeFromTrackedPlayers(EntityPlayerMP playerMP) {
+    public void removeFromTrackedPlayers(ServerPlayer playerMP) {
         trackedPlayers.remove(playerMP);
     }
 
-    public void updatePlayerEntity(EntityPlayerMP entityplayermp) {
+    public void updatePlayerEntity(ServerPlayer entityplayermp) {
         if(entityplayermp == trackedEntity) {
             return;
         }
@@ -183,40 +181,40 @@ public class EntityTrackerEntry {
                 trackedPlayers.add(entityplayermp);
                 entityplayermp.playerNetServerHandler.sendPacket(NetEntityHandler.getSpawnPacket(this));
                 if (trackedEntity.sendAdditionalData) {
-                    entityplayermp.playerNetServerHandler.sendPacket(new Packet42EntityTagData(trackedEntity));
+                    entityplayermp.playerNetServerHandler.sendPacket(new EntityTagDataPacket(trackedEntity));
                 }
                 if(shouldSendMotionUpdates) {
-                    entityplayermp.playerNetServerHandler.sendPacket(new Packet28EntityVelocity(trackedEntity.id, trackedEntity.xd, trackedEntity.yd, trackedEntity.zd));
+                    entityplayermp.playerNetServerHandler.sendPacket(new SetEntityMotionPacket(trackedEntity.id, trackedEntity.xd, trackedEntity.yd, trackedEntity.zd));
                 }
                 ItemStack[] aitemstack = trackedEntity.getInventory();
                 if(aitemstack != null) {
                     for(int i = 0; i < aitemstack.length; i++) {
-                        entityplayermp.playerNetServerHandler.sendPacket(new Packet5PlayerInventory(trackedEntity.id, i, aitemstack[i]));
+                        entityplayermp.playerNetServerHandler.sendPacket(new SetEquippedItemPacket(trackedEntity.id, i, aitemstack[i]));
                     }
                 }
-                if(trackedEntity instanceof EntityPlayer) {
-                    EntityPlayer entityplayer = (EntityPlayer)trackedEntity;
+                if(trackedEntity instanceof Player) {
+                    Player entityplayer = (Player)trackedEntity;
                     if(entityplayer.isPlayerSleeping())
                     {
-                        entityplayermp.playerNetServerHandler.sendPacket(new Packet17Sleep(trackedEntity, 0, MathHelper.floor_double(trackedEntity.x), MathHelper.floor_double(trackedEntity.y), MathHelper.floor_double(trackedEntity.z)));
+                        entityplayermp.playerNetServerHandler.sendPacket(new SleepPacket(trackedEntity, 0, MathHelper.floor(trackedEntity.x), MathHelper.floor(trackedEntity.y), MathHelper.floor(trackedEntity.z)));
                     }
                 }
             }
         } else if(trackedPlayers.contains(entityplayermp)) {
             trackedPlayers.remove(entityplayermp);
-            entityplayermp.playerNetServerHandler.sendPacket(new Packet29DestroyEntity(trackedEntity.id));
+            entityplayermp.playerNetServerHandler.sendPacket(new RemoveEntityPacket(trackedEntity.id));
         }
     }
 
-    public void updatePlayerEntities(List<EntityPlayer> list) {
-        for (EntityPlayer player : list) {
-            updatePlayerEntity((EntityPlayerMP) player);
+    public void updatePlayerEntities(List<Player> list) {
+        for (Player player : list) {
+            updatePlayerEntity((ServerPlayer) player);
         }
     }
-    public void removeTrackedPlayerSymmetric(EntityPlayerMP playerMP) {
+    public void removeTrackedPlayerSymmetric(ServerPlayer playerMP) {
         if(trackedPlayers.contains(playerMP)) {
             trackedPlayers.remove(playerMP);
-            playerMP.playerNetServerHandler.sendPacket(new Packet29DestroyEntity(trackedEntity.id));
+            playerMP.playerNetServerHandler.sendPacket(new RemoveEntityPacket(trackedEntity.id));
         }
     }
 }
diff --git a/src/main/java/net/minecraft/server/entity/ServerSkinVariantList.java b/src/main/java/net/minecraft/server/entity/ServerSkinVariantList.java
index 504b88172..4c79c58aa 100644
--- a/src/main/java/net/minecraft/server/entity/ServerSkinVariantList.java
+++ b/src/main/java/net/minecraft/server/entity/ServerSkinVariantList.java
@@ -1,39 +1,12 @@
 package net.minecraft.server.entity;
 
-import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.SkinVariantList;
-import net.minecraft.core.entity.animal.EntityChicken;
-import net.minecraft.core.entity.animal.EntityCow;
-import net.minecraft.core.entity.animal.EntityPig;
-import net.minecraft.core.entity.animal.EntitySquid;
-import net.minecraft.core.entity.monster.EntitySkeleton;
-import net.minecraft.core.entity.monster.EntitySnowman;
-import net.minecraft.core.entity.monster.EntitySpider;
-import net.minecraft.core.entity.monster.EntityZombie;
-
-import java.util.HashMap;
-import java.util.Map;
-
-public class ServerSkinVariantList
-    extends SkinVariantList {
-    private static final Map<String, Integer> entitySkinCounts = new HashMap<>();
-    public static void registerSkinCount(Class<? extends Entity> entityClass, int numSkins) {
-        entitySkinCounts.put(entityClass.getName(), numSkins);
-    }
-
-    static {
-        registerSkinCount(EntityChicken.class, 4);
-        registerSkinCount(EntityCow.class, 4);
-        registerSkinCount(EntityPig.class, 5);
-        registerSkinCount(EntitySkeleton.class, 5);
-        registerSkinCount(EntitySnowman.class, 5);
-        registerSkinCount(EntitySpider.class, 4);
-        registerSkinCount(EntitySquid.class, 4);
-        registerSkinCount(EntityZombie.class, 16);
-    }
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
+public class ServerSkinVariantList extends SkinVariantList {
     @Override
-    public int getNumSkinsForEntity(Class<? extends Entity> entityClass) {
-        return entitySkinCounts.getOrDefault(entityClass.getName(), 1);
+    public @NotNull String getSkinReference(@Nullable String variantJsonPath, @NotNull String defaultKey, int skinIndex) {
+        return "";
     }
 }
